Index: branches/Robocode/HeuristicLab.Problems.Robocode/BestSolutionAnalyzer.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/BestSolutionAnalyzer.cs	(revision 9567)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/BestSolutionAnalyzer.cs	(revision 9570)
@@ -165,5 +165,5 @@
             //int shots = ShotsParameter.ActualValue.Value;
             //int moves = MovesParameter.ActualValue.Value;
-            var bestSolution = new Solution(bestTree, actualQuality);//, moves, shots);
+            var bestSolution = new Solution(bestTree, RobocodePathParameter.ActualValue.Value);//, moves, shots);
             // store the new solution in the best solution parameter
             BestSolutionParameter.ActualValue = bestSolution;
Index: branches/Robocode/HeuristicLab.Problems.Robocode/Evaluator.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/Evaluator.cs	(revision 9567)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/Evaluator.cs	(revision 9570)
@@ -116,7 +116,7 @@
             
             ISymbolicExpressionTree tree = TankProgramParameter.ActualValue;
-            XmlDocument doc = new XmlDocument();
+            //XmlDocument doc = new XmlDocument();
             //doc.Load("../tank.xml");
-            XmlNode node = doc.FirstChild.Clone();
+            XmlNode node = null;
             string path = RobocodePathParameter.ActualValue.Value;
 
Index: branches/Robocode/HeuristicLab.Problems.Robocode/Solution.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/Solution.cs	(revision 9567)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/Solution.cs	(revision 9570)
@@ -31,10 +31,10 @@
         }
 
-        private double quality;
+        private string path;
         [Storable]
-        public double Quality
+        public string Path
         {
-            get { return quality; }
-            private set { this.quality = value; }
+            get { return path; }
+            private set { this.path = value; }
         }
 
@@ -49,9 +49,9 @@
         }
 
-        public Solution(ISymbolicExpressionTree tree, double quality)// int moves, int shots)
+        public Solution(ISymbolicExpressionTree tree, string path)// int moves, int shots)
             : base("Solution", "A tank program.")
         {
             this.tree = tree;
-            this.quality = quality;
+            this.path = path;
             //this.moves = moves;
             //this.shots = shots;
Index: branches/Robocode/HeuristicLab.Problems.Robocode/SolutionCodeView.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/SolutionCodeView.cs	(revision 9567)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/SolutionCodeView.cs	(revision 9570)
@@ -21,4 +21,6 @@
     public partial class SolutionCodeView : NamedItemView
     {
+        private string Path { get; set; }
+
         public new Solution Content
         {
@@ -30,4 +32,5 @@
         {
             InitializeComponent();
+            this.Path = "F:/robocode/";
             this.programCode.Text = "";
         }
@@ -42,9 +45,10 @@
             else
             {
+                this.Path = Content.Path;
                 string code = Interpreter.InterpretProgramTree(Content.Tree.Root);
                 code = code.Replace("class output extends", "class BestSolution extends");
                 this.programCode.Text = code;
-                File.AppendAllText("F:/robocode/robots/Evaluation/PreviousBestSolution.java", "\r\n/**********************************************/\r\n" + code);
-                File.WriteAllText("F:/robocode/robots/Evaluation/BestSolution.java", code, System.Text.Encoding.Default);
+                File.AppendAllText(Path + "/robots/Evaluation/PreviousBestSolution.java", "\r\n/**********************************************/\r\n" + code);
+                File.WriteAllText(Path + "/robots/Evaluation/BestSolution.java", code, System.Text.Encoding.Default);
             }
         }
@@ -52,7 +56,8 @@
         private void btnRunInRobocode_Click(object sender, EventArgs e)
         {
+            string formattedPath = Path.Replace("/", "\\");
             ProcessStartInfo javaCompileInfo = new ProcessStartInfo();
             javaCompileInfo.FileName = "cmd.exe";
-            javaCompileInfo.Arguments = "/C javac -cp F:\\robocode\\libs\\robocode.jar F:\\robocode\\robots\\Evaluation\\BestSolution.java";
+            javaCompileInfo.Arguments = "/C javac -cp " + formattedPath + "\\libs\\robocode.jar " + formattedPath + "\\robots\\Evaluation\\BestSolution.java";
             javaCompileInfo.RedirectStandardOutput = true;
             javaCompileInfo.RedirectStandardError = true;
@@ -68,5 +73,5 @@
             evaluateCodeInfo.FileName = "cmd.exe";
             //javaCompileInfo.Arguments = "/C javac -cp C:\\robocode\\libs\\robocode.jar \"" + path + "\\Spaced Up\\output.java\"";
-            evaluateCodeInfo.Arguments = "/C java -classpath F:\\robocode\\libs;F:\\robocode\\libs\\robocode.core-1.8.1.0.jar;F:\\robocode\\libs\\robocode.jar;F:\\robocode\\libs\\picocontainer-2.14.2.jar BattleRunner Evaluation.BestSolution*";
+            evaluateCodeInfo.Arguments = "/C java -classpath " + formattedPath + "\\libs;" + formattedPath + "\\libs\\robocode.core-1.8.1.0.jar;" + formattedPath + "\\libs\\robocode.jar;" + formattedPath + "\\libs\\picocontainer-2.14.2.jar BattleRunner Evaluation.BestSolution*";
             //Console.WriteLine(javaCompileInfo.Arguments);
             evaluateCodeInfo.RedirectStandardOutput = true;