Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.accordion.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.accordion.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.accordion.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Accordion 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Accordion#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.all.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.all.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.all.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI CSS Framework 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.autocomplete.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.autocomplete.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.autocomplete.css	(revision 9582)
@@ -1,13 +1,9 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Autocomplete 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
+ *
  * http://docs.jquery.com/UI/Autocomplete#theming
  */
@@ -18,14 +14,9 @@
 
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Menu 1.8.11
  *
  * Copyright 2010, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Menu#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.button.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.button.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.button.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Button 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Button#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.core.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.core.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.core.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI CSS Framework 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Theming/API
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.datepicker.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.datepicker.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.datepicker.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Datepicker 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Datepicker#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.dialog.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.dialog.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.dialog.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Dialog 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Dialog#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.progressbar.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.progressbar.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.progressbar.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Progressbar 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Progressbar#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.resizable.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.resizable.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.resizable.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Resizable 1.8.11
  *
- * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)]
+ * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Resizable#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.selectable.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.selectable.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.selectable.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Selectable 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Selectable#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.slider.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.slider.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.slider.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Slider 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Slider#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.tabs.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.tabs.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.tabs.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI Tabs 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Tabs#theming
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.theme.css
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.theme.css	(revision 9508)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/themes/base/jquery.ui.theme.css	(revision 9582)
@@ -1,13 +1,8 @@
 /*
- * Note: While Microsoft is not the author of this file, Microsoft is
- * offering you a license subject to the terms of the Microsoft Software
- * License Terms for Microsoft ASP.NET Model View Controller 3.
- * Microsoft reserves all other rights. The notices below are provided
- * for informational purposes only and are not the license terms under
- * which Microsoft distributed this file.
- *
  * jQuery UI CSS Framework 1.8.11
  *
  * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ * http://jquery.org/license
  *
  * http://docs.jquery.com/UI/Theming/API